OpenTTD Source: NWidgetCore Class Reference

OpenTTD Source 14.0-beta3

Public Member Functions | Data Fields
NWidgetCore Class Reference
Hierarchical widgets

Base class for a 'real' widget. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetCore:

## Public Member Functions
| NWidgetCore (WidgetType tp, Colours colour, WidgetID index, uint fill_x, uint fill_y, uint32_t widget_data, StringID tool_tip)
| Initialization of a 'real' widget. More...
void | SetDataTip (uint32_t widget_data, StringID tool_tip)
| Set data and tool tip of the nested widget. More...
void | SetToolTip (StringID tool_tip)
| Set the tool tip of the nested widget. More...
void | SetTextStyle (TextColour colour, FontSize size)
| Set the text style of the nested widget. More...
void | SetAlignment (StringAlignment align)
| Set the text/image alignment of the nested widget. More...
void | SetLowered (bool lowered)
| Lower or raise the widget. More...
bool | IsLowered () const
| Return whether the widget is lowered.
void | SetDisabled (bool disabled)
| Disable (grey-out) or enable the widget. More...
bool | IsDisabled () const
| Return whether the widget is disabled.
void | FillWidgetLookup (WidgetLookup &widget_lookup) override
NWidgetCore * | GetWidgetFromPos (int x, int y) override
bool | IsHighlighted () const override
| Return whether the widget is highlighted.
TextColour | GetHighlightColour () const override
| Return the colour of the highlight.
void | SetHighlighted (TextColour highlight_colour) override
| Highlight the widget or not. More...
Public Member Functions inherited from NWidgetResizeBase
| NWidgetResizeBase (WidgetType tp, uint fill_x, uint fill_y)
| Constructor for resizable nested widgets. More...
void | AdjustPaddingForZoom () override
void | SetMinimalSize (uint min_x, uint min_y)
| Set minimal size of the widget. More...
void | SetMinimalSizeAbsolute (uint min_x, uint min_y)
| Set absolute (post-scaling) minimal size of the widget. More...
void | SetMinimalTextLines (uint8_t min_lines, uint8_t spacing, FontSize size)
| Set minimal text lines for the widget. More...
void | SetFill (uint fill_x, uint fill_y)
| Set the filling of the widget from initial size. More...
void | SetResize (uint resize_x, uint resize_y)
| Set resize step of the widget. More...
bool | UpdateMultilineWidgetSize (const std::string &str, int max_lines)
| Try to set optimum widget size for a multiline text widget. More...
bool | UpdateSize (uint min_x, uint min_y)
| Set absolute (post-scaling) minimal size of the widget. More...
bool | UpdateVerticalSize (uint min_y)
| Set absolute (post-scaling) minimal size of the widget. More...
void | AssignSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height, bool rtl) override
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor. More...
virtual void | SetupSmallestSize (Window *w)=0
virtual NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type. More...
template<class NWID >
NWID * | GetParentWidget ()
| Get parent widget of type NWID. More...
template<class NWID >
const NWID * | GetParentWidget () const
| Get parent widget of type NWID. More...
virtual void | SetHighlighted ([[maybe_unused]] TextColour highlight_colour)
void | SetPadding (uint8_t top, uint8_t right, uint8_t bottom, uint8_t left)
| Set additional space (padding) around the widget. More...
void | SetPadding (const RectPadding &padding)
| Set additional space (padding) around the widget. More...
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step. More...
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step. More...
virtual void | Draw (const Window *w)=0
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint). More...
Rect | GetCurrentRect () const
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance. More...
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances. More...
void | operator delete (void *ptr)
| Memory release for a single class instance. More...
void | operator delete[] (void *ptr)
| Memory release for an array of class instances. More...

## Data Fields
NWidgetDisplay | disp_flags
| Flags that affect display and interaction with the widget.
Colours | colour
| Colour of this widget.
const WidgetID | index
| Index of the nested widget (`-1` means 'not used').
uint32_t | widget_data
| Data of the widget. More...
StringID | tool_tip
| Tooltip of the widget. More...
WidgetID | scrollbar_index
| Index of an attached scrollbar.
TextColour | highlight_colour
| Colour of highlight.
TextColour | text_colour
| Colour of text within widget.
FontSize | text_size
| Size of text within widget.
StringAlignment | align
| Alignment of text/image within widget.
Data Fields inherited from NWidgetResizeBase
uint | min_x
| Minimal horizontal size of only this widget.
uint | min_y
| Minimal vertical size of only this widget.
bool | absolute
| Set if minimum size is fixed and should not be resized.
uint | uz_min_x
| Unscaled Minimal horizontal size of only this widget.
uint | uz_min_y
| Unscaled Minimal vertical size of only this widget.
uint8_t | uz_text_lines
| 'Unscaled' text lines, stored for resize calculation.
uint8_t | uz_text_spacing
| 'Unscaled' text padding, stored for resize calculation.
FontSize | uz_text_size
| 'Unscaled' font size, stored for resize calculation.
Data Fields inherited from NWidgetBase
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
int | pos_x
| Horizontal position of top-left corner of the widget in the window.
int | pos_y
| Vertical position of top-left corner of the widget in the window.
RectPadding | padding
| Padding added to the widget. Managed by parent container widget. (parent container may swap left and right for RTL)
RectPadding | uz_padding
| Unscaled padding, for resize calculation.
NWidgetBase * | parent
| Parent widget of this widget, automatically filled in when added to container.

## Additional Inherited Members
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height)
| Store size and position. More...

## Detailed Description

Base class for a 'real' widget.

Definition at line 356 of file widget_type.h.

## Constructor & Destructor Documentation

## ◆ NWidgetCore()

NWidgetCore::NWidgetCore | ( | WidgetType | tp,
|  | Colours | colour,
|  | WidgetID | index,
|  | uint | fill_x,
|  | uint | fill_y,
|  | uint32_t | widget_data,
|  | StringID | tool_tip
| ) |  |

Initialization of a 'real' widget.

Parameters

  tp | Type of the widget.
  colour | Colour of the widget.
  index | Index of the widget.
  fill_x | Default horizontal filling.
  fill_y | Default vertical filling.
  widget_data | Data component of the widget.

See also
  Widget::data

Parameters

  tool_tip | Tool tip of the widget.

See also
  Widget::tooltips

Definition at line 1078 of file widget.cpp.

References colour, scrollbar_index, text_colour, tool_tip, widget_data, and WWT_CAPTION.

## Member Function Documentation

## ◆ FillWidgetLookup()

void NWidgetCore::FillWidgetLookup | ( | WidgetLookup & | widget_lookup | ) |
| overridevirtual

Fill the Window::widget_lookup with pointers to nested widgets in the tree.

Parameters

  widget_lookup | The WidgetLookup.

Implements NWidgetBase.

Reimplemented in NWidgetBackground.

Definition at line 1129 of file widget.cpp.

References index.

## ◆ GetWidgetFromPos()

NWidgetCore * NWidgetCore::GetWidgetFromPos | ( | int | x,
|  | int | y
| ) |  |
| overridevirtual

Retrieve a widget by its position.

Parameters

  x | Horizontal position relative to the left edge of the window.
  y | Vertical position relative to the top edge of the window.

Returns
  Returns the deepest nested widget that covers the given position, or `nullptr` if no widget can be found.

Implements NWidgetBase.

Reimplemented in NWidgetBackground.

Definition at line 1134 of file widget.cpp.

## ◆ SetAlignment()

void NWidgetCore::SetAlignment | ( | StringAlignment | align | ) |

Set the text/image alignment of the nested widget.

Parameters

  align | Alignment to use.

Definition at line 1124 of file widget.cpp.

References align.

Referenced by NWidgetBackground::NWidgetBackground(), and NWidgetLeaf::NWidgetLeaf().

## ◆ SetDataTip()

void NWidgetCore::SetDataTip | ( | uint32_t | widget_data,
|  | StringID | tool_tip
| ) |  |

Set data and tool tip of the nested widget.

Parameters

  widget_data | Data to use.
  tool_tip | Tool tip string to use.

Definition at line 1094 of file widget.cpp.

References tool_tip, and widget_data.

Referenced by NWidgetScrollbar::NWidgetScrollbar(), and SelectCompanyManagerFaceWindow::SelectDisplayPlanes().

## ◆ SetDisabled()

void NWidgetCore::SetDisabled | ( | bool | disabled | ) |
| inline

Disable (grey-out) or enable the widget.

Parameters

  disabled | Widget must be disabled.

Definition at line 429 of file widget_type.h.

References CLRBITS, disp_flags, ND_DISABLED, and SETBITS.

Referenced by Window::SetWidgetDisabledState(), ScriptDebugWindow::UpdateAIButtonsState(), and ScriptDebugWindow::UpdateGSButtonState().

## ◆ SetHighlighted()

void NWidgetCore::SetHighlighted | ( | TextColour | highlight_colour | ) |
| inlineoverride

Highlight the widget or not.

Parameters

  highlight_colour | Widget must be highlighted (blink).

Definition at line 392 of file widget_type.h.

References disp_flags.

## ◆ SetLowered()

void NWidgetCore::SetLowered | ( | bool | lowered | ) |
| inline

Lower or raise the widget.

Parameters

  lowered | Widget must be lowered (drawn pressed down).

Definition at line 414 of file widget_type.h.

References CLRBITS, disp_flags, ND_LOWERED, and SETBITS.

Referenced by ScriptDebugWindow::UpdateAIButtonsState(), and ScriptDebugWindow::UpdateGSButtonState().

## ◆ SetTextStyle()

void NWidgetCore::SetTextStyle | ( | TextColour | colour,
|  | FontSize | size
| ) |  |

Set the text style of the nested widget.

Parameters

  colour | TextColour to use.
  size | Font size to use.

Definition at line 1105 of file widget.cpp.

References colour, text_colour, and text_size.

## ◆ SetToolTip()

void NWidgetCore::SetToolTip | ( | StringID | tool_tip | ) |

Set the tool tip of the nested widget.

Parameters

  tool_tip | Tool tip string to use.

Definition at line 1115 of file widget.cpp.

References tool_tip.

## Field Documentation

## ◆ tool_tip

StringID NWidgetCore::tool_tip

Tooltip of the widget.

See also
  Widget::tootips

Definition at line 380 of file widget_type.h.

Referenced by NWidgetCore(), SetDataTip(), and SetToolTip().

## ◆ widget_data

uint32_t NWidgetCore::widget_data

Data of the widget.

See also
  Widget::data

Definition at line 379 of file widget_type.h.

Referenced by NWidgetCore(), SetDataTip(), and NWidgetBackground::SetupSmallestSize().

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp